import React, { useState, useCallback, useEffect } from 'react';
import ReactDOM from 'react-dom';
//import { arc } from 'd3';
import { csv, arc, pie } from 'd3';
import { msgOut } from './message';

const csvUrl =
  'https://gist.githubusercontent.com/curran/b236990081a24761f7000567094914e0/raw/cssNamedColors.csv';

//console.log(arc);
const width = 960;
const height = 500;
const centerX = width / 2;
const centerY = height / 2;
const circleRadius = 60;
const strokeWidth = 6;
const initialMousePosition = { x: width / 2, y: height / 2 };

const pieArc = arc()
  .innerRadius(width / 6)
  .outerRadius(width / 3);

//This is not working
//class App extends React.Component {
//  render() {
const App = () => {
  const [data, setData] = useState(null);

  useEffect(() => {
    csv(csvUrl).then(setData);
    //  d3.csv(csvUrl).then(data => {
    // csv(csvUrl).then(data => {
    //   console.log("fetching data...");
    //   setData(data);
    // });
  }, []);

  if (!data) {
    return <pre>Loading ...</pre>;
  }

  //  console.log(data[0]);

  return (
    <svg width={width} height={height}>
      <g transform={`translate(${centerX},${centerY})`}>
        {pie()
          .value(1)(data)
          .map(d => (
            <path fill={d.data['RGB hex value']} d={pieArc(d)} />
            // data.map((d, i) => (
            // <path
            //   fill={d['RGB hex value']}
            //   d={pieArc({
            //     startAngle: i / data.length * 2 * Math.PI,
            //     endAngle: (i + 1) / data.length * 2 * Math.PI
            //   })}
            //   />
          ))}
      </g>
    </svg>
  )//;
}//;
//}
const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
